(function() {
  var Request, _;

  Request = require('./request');

  _ = require('underscore');

  module.exports = (function() {
    /*
    */
    function _Class(router) {
      this.router = router;
      this._pluginsByName = {};
      this._using = [];
    }

    _Class.prototype.using = function() {
      return this._using;
    };

    /*
    */

    _Class.prototype.add = function(plugin) {
      var mod, plg, _i, _len;
      if (plugin instanceof Array) {
        for (_i = 0, _len = plugin.length; _i < _len; _i++) {
          plg = plugin[_i];
          this.add(plg);
        }
        return;
      }
      this._using.push(plugin);
      mod = plugin(this.router);
      this._pluginsByName[mod.name] = mod;
      _.extend(this.router._requestBuilder, mod.request);
      _.extend(this.router, mod.router);
      if (mod.director) return this.router.directors[mod.name] = mod.director;
    };

    /*
    */

    _Class.prototype.get = function(name) {
      return this._pluginsByName[name];
    };

    /*
    	 Used incase the listener needs to be handler for a particular reason, e.g: push -pull /some/route would be a binding.
    */

    _Class.prototype.newListener = function(listener) {
      return this._emit('newListener', listener);
    };

    /*
    */

    _Class.prototype._emit = function(type, data) {
      var plugin, pluginName, _results;
      _results = [];
      for (pluginName in this._pluginsByName) {
        plugin = this._pluginsByName[pluginName];
        if (plugin[type]) {
          _results.push(plugin[type](data));
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    };

    return _Class;

  })();

}).call(this);
